searchNodes=[{"doc":"Generates guides documentation.","ref":"Mix.Tasks.Ggity.Docs.html","title":"Mix.Tasks.Ggity.Docs","type":"task"},{"doc":"Configures and generates an iolist representing an SVG plot. The Plot module is GGity's public interface. A Plot struct is created with new/3 , specifying the data and aesthetic mappings to be used, along with options associated with the plot's general appearance. Data must be provided as a list of maps, where each map in the list represents an observation, and the map's keys represent variable names. GGity does not perform any validation of the data ; data is assumed to be clean and not to have missing values. Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) Mappings are specified using maps, where the map's keys are the names of supported aesthetics, and the values are the names of variables in the data. Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) A plot layer (represented as a struct that implements the GGity.Geom protocol) is added to the plot using functions such as geom_point/3 or geom_line/3 . As layers are assembled into a plot, the scales for each aesthetic are calculated using the data assigned to each aesthetic in each layer. Scales generate functions that transform data into an aesthetic value (e.g, an x coordinate or a color) and functions that transform an aesthetic value back into an observation (for the purpose of drawing axes or legends). The plot will assign default scales based on the type of data assigned to each aesthetic in each layer (by examining the value in the first row of the data), typically mapping numerical data to a continuous scale (if available) and binary data to a discrete scale. These assignments can be overridden by passing the Plot struct to a scale-setting function, e.g. scale_[scale_type]/2 . For x values only, GGity will assign at date/datetime scale if the data mapped to the :x aesthetic is a Date , DateTime or NaiveDateTime struct. Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . plot ( ) plot/1 generates an iolist that represents the plot. Text elements (e.g. the plot title, axis labels, legend labels) are escaped using the logic from Plug.HTML , but other values are not, so users still need to be mindful of the risks of generating plots using user-supplied data or parameters.","ref":"GGity.Plot.html","title":"GGity.Plot","type":"module"},{"doc":"Adds geoms to a plot from raw data. annotate/3 can be used to add annotations to a plot. The function takes a plot, a type of geom and a keyword list of values and options. The keyword list must include values for the aesthetics required to draw the geom, and can also include any other options that could be passed to constructor for that geom. Supported geoms and required aesthetics include: :text - :x , :y , :label","ref":"GGity.Plot.html#annotate/3","title":"GGity.Plot.annotate/3","type":"function"},{"doc":"Adds a ribbon geom to the plot with the position: :stack option set. geom_area/3 is a convenience alias for geom_ribbon/3 that sets the :position option to :stack in order to create stacked area chart. See geom_ribbon/3 for available aesthetics and options. Note that stacked ribbon charts are not yet supported - mappings to the :y_min aesthetic will be ignored.","ref":"GGity.Plot.html#geom_area/3","title":"GGity.Plot.geom_area/3","type":"function"},{"doc":"Adds a bar geom to the plot. Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset. Accepts a mapping and/or additional options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x mapping. Bar geoms support mapping data to the following aesthetics, which use the noted default scales: :x (required) :y (required to draw the geom, but not typically specified for bar geoms - see below) :alpha :fill Bar geoms also support providing fixed values (specified as options, e.g. color: &quot;blue&quot; ) for the optional aesthetics above. A fixed value is assigned to the aesthetic for all observations. geom_bar/3 uses the :count stat, which counts the number of observations in the data for each combination of mapped aesthetics and assigns that value to the :y aesthetic. To create a bar chart with bars tied values of a specific variable use specify stat: :identity or use geom_col/3 , which is identical to calling geom_bar/3 with the stat: :identity option. In either case, if stat: :identity is called, a variable in the data must be mapped to the :y aesthetic. Other supported options: :custom_attributes - a function that takes two arguments: first, the Plot struct, and second, the data record (a map - note that this is the data AFTER the statistical transformation has been supplied) to be mapped to the bar geom. The function must return a keyword list of property-value pairs, which are added to the point element drawn in the generated SVG. This can be used to add Phoenix event handlers or any other attributes based on characteristic of the plot and the data being mapped to the geom. See geom_point/3 for a more explanation of the :custom_attributes option. :key_glyph - Type of glyph to use in the legend key. Available values are :a , :point , :path , :rect and :timeseries . Defaults to :rect . :position - Available values are: :identity (bars sit on top of each other; not recommended), :stack (one bar per :x value) :dodge (one bar per unique :x / :fill value pair). Defaults to :stack . :stat - an atom referring to a statistical transformation function in the GGity.Stat module that is to be applied to the data. Defaults to :count (see above).","ref":"GGity.Plot.html#geom_bar/3","title":"GGity.Plot.geom_bar/3","type":"function"},{"doc":"Adds a boxplot geom to the plot. Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset. Accepts a mapping and/or additional options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x mapping, for example. Boxplot geoms support mapping data to the following aesthetics, which use the noted scales: :x (required - should be a discrete variable) :y (required - the value for which percentile statistics are calculated) :alpha :color :fill geom_boxplot/3 uses the :boxplot stat, which calculates the following for the variable mapped to the :y aesthetic: 25th and 75th percentiles (the y-coordinates of the top and bottom of the box) median (the y-coordinate of the line in the middle of the box) &quot;ymin&quot; and &quot;ymax&quot; (the outlying y-coordinates of the vertical lines extending from the top and bottom of each box. &quot;ymin&quot; and &quot;ymax&quot; represent the range of values between the 25th/75th percentiles minus/plus 1.58 multiplied by the interquartile range, respectively. The interquartile range is the difference between the 75th and 25th percentile values. Values mapped to :y that are less than &quot;ymin&quot; or greater than &quot;ymax&quot; (&quot;outiers&quot;) are plotted as individual points. Other supported options: :custom_attributes - a function that takes two arguments: first, the Plot struct, and second, the data record (a map - note that this is the data AFTER the statistical transformation has been supplied) to be mapped to the boxplot geom. The function must return a keyword list of property-value pairs, which are added to the point element drawn in the generated SVG. This can be used to add Phoenix event handlers or any other attributes based on characteristic of the plot and the data being mapped to the geom. See geom_point/3 for a more explanation of the :custom_attributes option. :outlier_color - color of outlier points. Defaults to &quot;black&quot; . :outlier_shape - shape of outlier points ( :circle , :triangle , :square , :diamond ) Defaults to :circle . Setting this value to :na omits the outliers from the plot entirely. :outlier_size - size of outlier points. Defaults to 2 . GGity uses method &quot;Type 7&quot; to calculate percentiles, in conformance with the default used by R .","ref":"GGity.Plot.html#geom_boxplot/3","title":"GGity.Plot.geom_boxplot/3","type":"function"},{"doc":"Shorthand for geom_bar(plot, stat: :identity) . Produces a bar chart similar to geom_bar/3 , but uses the values of observations mapped to the :y aesthetic (instead of observation counts) to calculate the height of the bars. See geom_bar/3 for supported options.","ref":"GGity.Plot.html#geom_col/3","title":"GGity.Plot.geom_col/3","type":"function"},{"doc":"Adds a line geom to the plot. Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset. Accepts a mapping and/or additional options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x or :y mappings. Note that the line geom sorts the data by the values for the variable mapped to the :x aesthetic using Erlang default term ordering. Line geoms support mapping data to the following aesthetics, which use the noted default scales: :x (required) :y (required) :alpha :color :linetype :size Line geoms also support providing fixed values (specified as options, e.g. color: &quot;blue&quot; ) for the optional aesthetics above. A fixed value is assigned to the aesthetic for all observations. Other supported options: :key_glyph - Type of glyph to use in the legend key. Available values are :path and :timeseries . By default this value is assigned based on the type of the value in the first row of the data for the variable mapped to the :x aesthetic.","ref":"GGity.Plot.html#geom_line/3","title":"GGity.Plot.geom_line/3","type":"function"},{"doc":"Adds a layer with a point geom to the plot. Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset. Accepts a mapping and/or additional options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x or :y mappings. Point geoms support mapping data to the following aesthetics, which use the noted default scales: :x (required) :y (required) :alpha :color :shape :size Point geoms also support providing fixed values (specified as options, e.g. color: &quot;blue&quot; ) for the optional aesthetics above. A fixed value is assigned to the aesthetic for all observations. Other supported options: :custom_attributes - a function that takes two arguments: first, the Plot struct, and second, the data record (a map) to be mapped to the point geom. The function must return a keyword list of property-value pairs, which are added to the point element drawn in the generated SVG. This can be used to add Phoenix event handlers or any other attributes based on characteristic of the plot and the data being mapped to the geom. :key_glyph - Type of glyph to use in the legend key. Available values are :point , :path and :timeseries ; defaults to :point . :stat - an atom referring to a statistical transformation function in the GGity.Stat module that is to be applied to the data. Defaults to :identity (i.e., no transformation). Custom Attributes Custom attributes are a powerful hook for interactivity. For example, to add a simple javascript alert based tooltip: Plot . new ( data , %{ x : &quot;x&quot; , y : &quot;y&quot; } ) |&gt; Plot . geom_point ( custom_attributes : fn plot , row -&gt; [ onclick : &quot;alert(&#39; \#{ plot . labels . x } : \#{ row [ &quot;x&quot; ] } &#39;)&quot; ] end ) # I hope the plot x-axis label is trusted data... or a Phoenix LiveView event handler: Plot . new ( data , %{ x : &quot;x&quot; , y : &quot;y&quot; } ) |&gt; Plot . geom_point ( custom_attributes : fn _plot , row -&gt; [ phx_click : &quot;filter_by_y&quot; , phx_value_y : row [ &quot;y&quot; ] ] end ) The values (but not the keys) generated are HTML-escaped but otherwise not sanitized; users should be mindful of the risks of using untrusted data to generate custom attribute values.","ref":"GGity.Plot.html#geom_point/3","title":"GGity.Plot.geom_point/3","type":"function"},{"doc":"Adds a ribbon geom to the plot. Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset. Accepts a mapping and/or additional options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x mapping. Ribbon geoms support mapping data to the following aesthetics, which use the noted default scales: :x (required) :y_max (required) - defines the top boundary of the ribbon :y_min - defines the bottom boundary of the ribbon; defaults to zero :alpha :fill A ribbon geom with no :y_min specified is essentially an area chart. To draw a stacked area chart, set the :position option to :stack , or use the geom_area/3 convenience function. Ribbon geoms also support providing fixed values (specified as options, e.g. fill: &quot;blue&quot; ) for the :alpha and :fill aesthetics above. A fixed value is assigned to the aesthetic for all observations. Fixed values can also be specified for: :color - ribbon border color :size - ribbon border color width Other supported options: :key_glyph - Type of glyph to use in the legend key. Available values are :a , :point , :path , :rect and :timeseries . Defaults to :rect . :position - Available values are: :identity (ribbons overlay one another), :stack (ribbons stacked on the y-axis; note ) Defaults to :identity . Note that stacked ribbon charts are not yet supported - mappings to the :y_min aesthetic will be ignored is :position is set to :stack .","ref":"GGity.Plot.html#geom_ribbon/3","title":"GGity.Plot.geom_ribbon/3","type":"function"},{"doc":"Adds a layer with a text geom to the plot. Accepts an alternative dataset to be used; if one is not provided defaults to the plot dataset. A common use for text geoms is labelling of bar or point geoms. For bar chart labels in particular, it is important to specify the same stat and position adjustment for the text geom as that specified for the bar chart. Accepts a mapping and/or additional options to be used. The provided mapping is merged with the plot mapping for purposes of the geom - there is no need to re-specify the :x or :y mappings. Text geoms support mapping data to the following aesthetics, which use the noted default scales: :x (required) :y (required) :label (required - the text to be displayed) :group :alpha :color :size The :group aesthetic is generally needed for bar chart labelling, where the :fill or :alpha aesthetic is mapped to a value in the data, in those scenarios, the text geom position adjustment must match the bar, and the :group aesthetic for the text geom should be mapped to the variable mapped to :fill or :alpha on the bar chart layer. See the visual examples code for examples. Text geoms also support providing fixed values (specified as options, e.g. color: &quot;blue&quot; ) for the optional aesthetics above. A fixed value is assigned to the aesthetic for all observations. Other supported options: :custom_attributes - a function that takes two arguments: first, the Plot struct, and second, the data record (a map) to be mapped to the text geom. The function must return a keyword list of property-value pairs, which are added to the point element drawn in the generated SVG. This can be used to add Phoenix event handlers or any other attributes based on characteristic of the plot and the data being mapped to the geom. See geom_point/3 for a more explanation of the :custom_attributes option. :family - The font family used to display the text; equivalent to the SVG font-family attribute. Defaults to &quot;Helvetica, Arial, sans-serif&quot; . :fontface - Equivalent to SVG font-weight attribute. Defaults to :normal . :hjust - Horizontal alignment of the text relevant to element's :x value. Valid values are :left , :center and :right . Defaults to :center . :key_glyph - Type of glyph to use in the legend key. Available values are :a , :point , :path and :timeseries . Defaults to :a . nudge_x , :nudge_y - Adjust the x- or y-position value by the specified number of pixels. Both default to 0 . :position - Available values are :identity (no adjustment), :stack ( :y value represents cumulative value for a given :x value) or :dodge (one text element per unique pair of :x and other non- :y mapped aesthetics). Defaults to :identity . position_vjust - Adjust :y position vertically; expressed as a percentage of the calculated :y value after taking into account the specified position adjustment. Defaults to 1 . :stat - an atom referring to a statistical transformation function in the GGity.Stat module that is to be applied to the data. Defaults to :identity (i.e., no transformation). Supported values are :count and :identity . Where text geom is intended to serve as a label for another layer with the :count stat, the state for the text layer should :vjust - Baseline of the text relevant to element's :y value. Valid values are :top , :middle and :bottom . Defaults to :center .","ref":"GGity.Plot.html#geom_text/3","title":"GGity.Plot.geom_text/3","type":"function"},{"doc":"Manually sets the type of guide used for specified scales. Accepts a keyword list of aesthetics and values for the :guide options for the associated scales. Currently this is only used to turn legends on or off. Valid values are :legend (draw a legend) and :none (do not draw a legend). Example Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; } ) |&gt; Plot . geom_point ( color : &quot;color&quot; , shape : &quot;shape&quot; , size : &quot;size&quot; ) # By default all three legends will be drawn |&gt; Plot . guides ( shape : :none , size : :none ) # Plot will only draw a legend for the color scale","ref":"GGity.Plot.html#guides/2","title":"GGity.Plot.guides/2","type":"function"},{"doc":"Updates plot title, axis and legend labels. Accepts a keyword list where the keys are :title and/or the aesthetic(s) tied to the axes/legends to be labelled.","ref":"GGity.Plot.html#labs/2","title":"GGity.Plot.labs/2","type":"function"},{"doc":"Generates a Plot struct with provided data and aesthetic mappings. data must be passed in the form of a list of maps, where each map represents an observation or record, the map keys are variable names, and the map values represent the measurement of that variable for that observation.integer() Mappings tie variables to aesthetics, i.e. visual characteristics of the plot. A mapping is specified using a map, with key-value pairs representing the assignment of variables to available aesthetics. Mappings passed to new/3 must include key-value pairs for the :x aesthetic and the :y aesthetic. new/3 also supports several options that shortcut plot creation or alter the appearance of the plot. All graphical size units are in pixels. :area_padding - amount of blank space before the first tick and after the last tick on each axis (same value applied to both axes) defaults to 10 . :aspect_ratio - the ratio of the plot area height to :width . Defaults to 1.5. :breaks - the number of tick intervals on the x- and y axis (same value applied to both axes). This may be adjusted by the scale function based on the data. Defaults to 5 . :labels - a map specifying the titles of the plot ( :title ), x and y-axes ( :x and :y ) or legend title for another aesthetic (e.g. :color ). A nil value indicates no label. Defaults to %{title: :nil, x: nil, y: nil} . :margins - a map with keys :left , :top , :right and :bottom , specifying the plot margins. Default is %{left: 30, top: 10, right: 0, bottom: 0} . :panel_background_color - a string value (hex or CSS color name) for the panel background. Defaults to grey ( #eeeeee ) :y_label_padding - vertical distance between the y axis and its label. Defaults to 20 .","ref":"GGity.Plot.html#new/3","title":"GGity.Plot.new/3","type":"function"},{"doc":"Generates an iolist of SVG markup representing a Plot . SVG text elements (e.g. the plot title, axis labels, legend labels) are escaped using the logic from Plug.HTML , but other values are not, so users need to be mindful of the risks of generating plots using user-supplied data or parameters. The SVG's viewBox is set by the plot's :width and :aspect_ratio values.","ref":"GGity.Plot.html#plot/1","title":"GGity.Plot.plot/1","type":"function"},{"doc":"Sets geom point opacity for continuous data. This scale defines a mapping function that assigns an opacity to be mapped to a given value of the mapped variable. This function takes the following options: :range - a tuple with minimum (default - 0.1 ) and maximum (default - 1 ) values to be bound to the data","ref":"GGity.Plot.html#scale_alpha_continuous/2","title":"GGity.Plot.scale_alpha_continuous/2","type":"function"},{"doc":"Sets geom point opacity for categorical data. For categorical data for which a linear mapping of values to opacity is not appropriate, this scale generates a palette of evenly spaced opacity values mapped to each unique value of the data. The palette is generated such that the difference between each opacity value is maximized. The set of unique data values are sorted for the purpose of assigning them to an opacity and ordering the legend. This function also takes the following options: :labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option. :range - a tuple with minimum (default - 0.1 ) and maximum (default - 1 ) values to be bound to the data","ref":"GGity.Plot.html#scale_alpha_discrete/2","title":"GGity.Plot.scale_alpha_discrete/2","type":"function"},{"doc":"Sets geom point opacity using the value of the data mapped to the :alpha aesthetic. Can be used to manually assign opacity to individual data points by including an value with each observation. See scale_color_identity/1 for an example of identity scale use.","ref":"GGity.Plot.html#scale_alpha_identity/1","title":"GGity.Plot.scale_alpha_identity/1","type":"function"},{"doc":"Sets geom point color using the value of the data mapped to the color aesthetic. Can be used to manually assign colors to individual data points by including a color value with each observation. Such color values must be provided as a hex value or CSS color name. For example, with the dataset below, one could render points for :weight values as &quot;blue&quot; for low weights and &quot;red&quot; for high weights by assigning a value to the :point_color variable accordingly. [ %{ weight : 6 , age : 4 , point_color : &quot;blue&quot; } , %{ weight : 5 , age : 3 , point_color : &quot;blue&quot; } , %{ weight : 8 , age : 4 , point_color : &quot;red&quot; } , %{ weight : 7 , age : 4 , point_color : &quot;red&quot; } , ] |&gt; Plot . new ( %{ x : :weight , y : :age } ) |&gt; Plot . geom_point ( %{ color : :point_color } ) |&gt; Plot . scale_color_identity ( ) |&gt; Plot . plot","ref":"GGity.Plot.html#scale_color_identity/1","title":"GGity.Plot.scale_color_identity/1","type":"function"},{"doc":"Sets geom point colour using the Viridis color palettes. Viridis is used by ggplot2 and other libraries in part because it is optimized to maintain contrast when viewed by those with various types of color blindess. The scale is discrete - it is intended to map colors to categorical data. The scale generates a palette of evenly spaced values from the Viridis color palette and these are mapped to each unique value of the data. The palette is generated such that the visual difference between each color value is maximized. The set of unique data values are sorted for the purpose of assigning them to a color and ordering the legend. This function also takes the following options: :labels - specifies how legend item names (levels of the data mapped to the scale) should be formatted. See GGity.Labels for valid values for this option. :option - specifies which palette to use. Available palettes are :magma , :inferno , :plasma , :viridis (the default) and :cividis . These palettes can also be specified via their letter codes - :a , :b , :c , :d and :e , respectively. Examples of each color palette option can be generated using mix ggity.visual.scale_color_viridis .","ref":"GGity.Plot.html#scale_color_viridis/2","title":"GGity.Plot.scale_color_viridis/2","type":"function"},{"doc":"Sets fill color for fillable shapes (e.g., bars). Accepts the same options as scale_color_viridis/2 .","ref":"GGity.Plot.html#scale_fill_viridis/2","title":"GGity.Plot.scale_fill_viridis/2","type":"function"},{"doc":"","ref":"GGity.Plot.html#scale_label_identity/1","title":"GGity.Plot.scale_label_identity/1","type":"function"},{"doc":"Sets type of line for categorical data in line charts. This scale uses a palette of six line types ( :solid , :dashed , :dotted , :longdash , :dotdash and :twodash ) that are mapped to each unique value of the data. The set of unique data values are sorted for the purpose of assigning them to a line type (in the same order as listed above) and ordering the legend. If there are more than six unique values in the data, the line types are recycled per the order above. This function also takes the following options: :labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_linetype_discrete/2","title":"GGity.Plot.scale_linetype_discrete/2","type":"function"},{"doc":"Sets geom point marker shape for categorical data. This scale uses a palette of four marker types ( :circle , :square , :diamond and :triangle ) that are mapped to each unique value of the data. The set of unique data values are sorted for the purpose of assigning them to a size (using the shape order above) and ordering the legend. If there are greater than four unique values in the data, the shapes are recycled per the order above. This function also takes the following options: :labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_shape/2","title":"GGity.Plot.scale_shape/2","type":"function"},{"doc":"Sets geom point marker shape for categorical data using a custom palette. This scale requires a :values option be passed, which must contain a list of characters or valid shape names ( :circle , :square , :diamond or :triangle ) to be used as markers. These values are mapped to the unique values of the mapped variable in term order. The list must have as many values as there are unique values in the data. This function also takes the following (optional) options: :labels - specifies how legend item names (levels of the scale) should be formatted. See GGity.Labels for valid values for this option. [ %{ x : 6 , y : 4 , mood : &quot;happy&quot; } , %{ x : 5 , y : 3 , mood : &quot;ok&quot; } , %{ x : 8 , y : 4 , mood : &quot;sad&quot; } , %{ x : 7 , y : 4 , mood : &quot;sad&quot; } , ] |&gt; Plot . new ( %{ x : :x , y : :y } ) |&gt; Plot . geom_point ( %{ shape : :mood } , size : 7 ) |&gt; Plot . scale_shape_manual ( values : [ &quot;😀&quot; , &quot;😐&quot; , &quot;☹️&quot; ] ) |&gt; Plot . plot ( )","ref":"GGity.Plot.html#scale_shape_manual/2","title":"GGity.Plot.scale_shape_manual/2","type":"function"},{"doc":"Sets geom point size for continuous data. This scale defines a mapping function that assigns a shape area based on the given value of the mapped variable. This function takes the following options: :range - a tuple with minimum (default - 9 ) and maximum (default - 100 ) values to be bound to the data","ref":"GGity.Plot.html#scale_size/2","title":"GGity.Plot.scale_size/2","type":"function"},{"doc":"Sets geom point size using the value of the data mapped to the size aesthetic. Can be used to manually assign size to individual data points by including an value with each observation. Note that &quot;size&quot; is the marker diameter, not marker area (which is generally preferable but not yet implemented). See scale_color_identity/1 for an example of identity scale use.","ref":"GGity.Plot.html#scale_size_identity/1","title":"GGity.Plot.scale_size_identity/1","type":"function"},{"doc":"Sets geom x coordinate for continuous numerical data. This scale defines a mapping function that assigns a coordinate on the x axis to the value of the mapped variable. The scale also defines an inverse of this function that is used to generate axis tick labels. This function also takes the following options: :labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_x_continuous/2","title":"GGity.Plot.scale_x_continuous/2","type":"function"},{"doc":"Sets geom x coordinate for continuous Date data. This scale defines a mapping function that assigns a coordinate on the x axis to the value of the mapped variable. The scale also defines an inverse of this function that is used to generate axis tick labels. This function also takes the following options: :labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option. :date_labels - special formatting patterns for dates. If :date_labels is specified, the value of the :labels option will be overridden. :date_labels can be either a format string pattern that is accepted by NimbleStrftime : data |&gt; Plot . new ( %{ x : :date_variable , y : :other_variable } ) |&gt; Plot . geom_line ( ) |&gt; Plot . scale_x_date ( date_labels : &quot;%b %d %Y&quot; ) # Label format &quot;Jan 01 2001&quot; or a tuple {format, options} where format is the pattern and options is a keyword list of options accepted by NimbleStrftime.format/3 : rename_weekdays = fn day_of_week -&gt; { &quot;Monday&quot; , &quot;Tuesday&quot; , &quot;Hump Day&quot; , &quot;Thursday&quot; , &quot;Friday&quot; , &quot;Saturday&quot; , &quot;Sunday&quot; } |&gt; elem ( day_of_week - 1 ) end data |&gt; Plot . new ( %{ x : :date_variable , y : :other_variable } ) |&gt; Plot . geom_line ( ) |&gt; Plot . scale_x_date ( date_labels : { &quot;%A&quot; , day_of_week_names : rename_weekdays } ) # Ticks are just weekday names, Wednesday is Hump Day","ref":"GGity.Plot.html#scale_x_date/2","title":"GGity.Plot.scale_x_date/2","type":"function"},{"doc":"Sets geom x coordinate for continuous DateTime data. This scale defines a mapping function that assigns a coordinate on the x axis to the value of the mapped variable. The scale also defines an inverse of this function that is used to generate axis tick labels. This function also takes the following options: :labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option. :date_labels - special formatting patterns for dates. If :date_labels is specified, the value of the :labels option will be overridden. :date_labels can be either a format string pattern that is accepted by NimbleStrftime : See scale_x_date/2 for more usage examples. data |&gt; Plot . new ( %{ x : :datetime_variable , y : :other_variable } ) |&gt; Plot . geom_line ( ) |&gt; Plot . scale_x_datetime ( date_labels : &quot;%b %d H%H&quot; ) # Label format &quot;Jan 01 H01&quot;","ref":"GGity.Plot.html#scale_x_datetime/2","title":"GGity.Plot.scale_x_datetime/2","type":"function"},{"doc":"Sets geom x coordinate for discrete (categorical) data. This scale defines a mapping function that assigns a coordinate on the x axis to the value of the mapped variable. In the discrete case, this is equivalent to evenly distributing geoms across the x axis. This function also takes the following options: :labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_x_discrete/2","title":"GGity.Plot.scale_x_discrete/2","type":"function"},{"doc":"Sets geom y coordinate for continuous numerical data. This scale defines a mapping function that assigns a coordinate on the y axis to the value of the mapped variable. The scale also defines an inverse of this function that is used to generate axis tick labels. This function also takes the following options: :labels - specifies how break names (tick labels calculated by the scale) should be formatted. See GGity.Labels for valid values for this option.","ref":"GGity.Plot.html#scale_y_continuous/2","title":"GGity.Plot.scale_y_continuous/2","type":"function"},{"doc":"Updates the plot theme. GGity uses themes to style non-data plot elements. The default theme is similar to ggplot2's signature gray background/white gridline theme. theme/2 is used to update on or more elements of the plot theme by passing a keyword list of new elements and values, which are merged with those of the current theme. For supported elements and values, see GGity.Theme .","ref":"GGity.Plot.html#theme/2","title":"GGity.Plot.theme/2","type":"function"},{"doc":"Convenience method that returns an IO List with an XML declaration, in order to support output to a standalone .svg file. Plot.to_xml/2 takes a second argument specifying a fixed height for the SVG element. A fixed width is also added, equal to the height multiplied by the plot's aspect ration.","ref":"GGity.Plot.html#to_xml/1","title":"GGity.Plot.to_xml/1","type":"function"},{"doc":"","ref":"GGity.Plot.html#to_xml/2","title":"GGity.Plot.to_xml/2","type":"function"},{"doc":"Updates the plot x axis label.","ref":"GGity.Plot.html#xlab/2","title":"GGity.Plot.xlab/2","type":"function"},{"doc":"Updates the plot y axis label.","ref":"GGity.Plot.html#ylab/2","title":"GGity.Plot.ylab/2","type":"function"},{"doc":"","ref":"GGity.Plot.html#t:column/0","title":"GGity.Plot.column/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:mapping/0","title":"GGity.Plot.mapping/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:name/0","title":"GGity.Plot.name/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:options/0","title":"GGity.Plot.options/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:record/0","title":"GGity.Plot.record/0","type":"type"},{"doc":"","ref":"GGity.Plot.html#t:t/0","title":"GGity.Plot.t/0","type":"type"},{"doc":"Defines the data and functions used to style non-geom line elements. CSS presentation attributes: :color sets value of CSS stroke :size sets value of CSS stroke-width","ref":"GGity.Element.Line.html","title":"GGity.Element.Line","type":"module"},{"doc":"Constructor for a Line element. Setting the value of an attributed to nil will remove that property from the generated stylesheet altogether. Calling element_line(attributes) is equivalent to struct(GGity.Element.Line, attributes) .","ref":"GGity.Element.Line.html#element_line/1","title":"GGity.Element.Line.element_line/1","type":"function"},{"doc":"","ref":"GGity.Element.Line.html#t:t/0","title":"GGity.Element.Line.t/0","type":"type"},{"doc":"Defines the data and functions used to style non-geom rect elements. CSS presentation attributes: :fill - string: sets value of CSS fill Values must be valid CSS color names or hex values. :color - string: sets value of CSS stroke Values must be valid CSS color names or hex values. :size - number: sets value of CSS stroke-width Other attributes: :height - number: sets value of SVG height (height of the key glyph box)","ref":"GGity.Element.Rect.html","title":"GGity.Element.Rect","type":"module"},{"doc":"Constructor for a Rect element. Setting the value of an attributed to nil will remove that property from the generated stylesheet altogether. Calling element_rect(attributes) is equivalent to struct(GGity.Element.Line, attributes) .","ref":"GGity.Element.Rect.html#element_rect/1","title":"GGity.Element.Rect.element_rect/1","type":"function"},{"doc":"","ref":"GGity.Element.Rect.html#t:t/0","title":"GGity.Element.Rect.t/0","type":"type"},{"doc":"Defines the data and functions used to style non-geom text elements. CSS presentation attributes: :family - string: sets value of CSS font-family :face - string or integer: sets value of CSS font-weight Valid values: &quot;normal&quot; &quot;bold&quot; &quot;bolder&quot; &quot;lighter&quot; &quot;initial&quot; &quot;inherit&quot; A multiple of 100 between 100 and 900 :color - string: sets value of CSS fill Values must be valid CSS color names or hex values. :size - number: sets value of CSS font-size in pixels Other attributes: :angle - number (between 0 and 90): sets the value passed to transform: rotate() for the purpose of rotating x axis tick labels (has no effect when set for other theme elements)","ref":"GGity.Element.Text.html","title":"GGity.Element.Text","type":"module"},{"doc":"Constructor for a Text element. Setting the value of an attributed to nil will remove that property from the generated stylesheet altogether. Calling element_text(attributes) is equivalent to struct(GGity.Element.Text, attributes) .","ref":"GGity.Element.Text.html#element_text/1","title":"GGity.Element.Text.element_text/1","type":"function"},{"doc":"","ref":"GGity.Element.Text.html#t:t/0","title":"GGity.Element.Text.t/0","type":"type"},{"doc":"Themes store style and other attributes of non-geom elements of a plot. GGity generates an embedded stylesheet for the CSS presentation attributes of these elements that ties the specified styles to custom CSS classes that are automatically generated for each type of element. Classes are generated irrespective of theme values, thereby allowing for the use of external stylesheets. To avoid overriding a style in an external stylesheet, set the value of the attribute(s) styled externally to nil in a plot's theme - GGity will not include a style in the embedded stylesheet for an attribute with a nil value. Each key of a Theme struct represents a class. Allowed types for each item include: nil - no selector or styles are generated for that class %Element.Line{} struct - generates styles for a line element %Element.Rect{} struct - generates styles for a rect element %Element.Text{} struct - generates styles for a text element An integer - for non-CSS attributes of a given element, e.g., :axis_ticks_length , which sets the value of the length attribute See the documentation for each element type for allowed keys and values. Keys conform to the ggplot2 API, which means that a given attribute does not necessarily correspond to the CSS attribute of the same name. For example, :size means CSS stroke-width for lines and rectangles, and CSS font-size for text. Element structs can be generated using the constructor function for that element type: import GGity.Element.Text alias GGity.Plot Plot . theme ( plot , axis_text : element_text ( color : &quot;green&quot; , size : 12 ) ) #=&gt; equivalent to Plot.theme(plot, axis_text: %GGity.Element.Text{color: &quot;green&quot;, size 12}) The following attributes are supported: :text style for all non-data text; overridden by other text attributes ( Element.Text ) :axis_line x- and y axes lines ( Element.Line ) :axis_line_x x axis; overrides :axis_line ( Element.Line ) :axis_line_y y axis; overrides :axis_line ( Element.Line ) :axis_text x- and y axis tick label text ( Element.Text ) :axis_text_x x axis tick label text; overrides :axis_text ( Element.Text ) :axis_text_y y axis tick label text; overrides :axis_text ( Element.Text ) :axis_ticks x- and y axis ticks ( Element.Line ) :axis_line_x x axis ticks; overrides :axis_ticks ( Element.Line ) :axis_line_y y axis ticks; overrides :axis_ticks ( Element.Line ) :axis_ticks_length length of x- and y axis ticks ( Integer - non-CSS attribute) :axis_ticks_x_length length of x axis tick; overrides :axis_tick_length ( Integer ) :axis_ticks_y_length length of y axis tick; overrides :axis_tick_length ( Integer ) :axis_title x- and y axis title text ( Element.Text ) :axis_title_x x axis title text; overrides :axis_title ( Element.Text ) :axis_title_y y axis title text; overrides :axis_title ( Element.Text ) :legend_key legend key glyph box ( Element.Rect ) :legend_text legend item text ( Element.Text ) :legend_title legend title text ( Element.Text ) :panel_background panel (area bounded by axes) background ( Element.Rect ) :panel_border panel border ( Element.Line ) :panel_grid minor and major gridlines ( Element.Line ) :panel_grid_major major gridlines; overrides panel_grid ( Element.Line ) :panel_grid_minor minor gridlines; overrides panel_grid ( Element.Line ) :plot_title plot title text ( Element.Text ) :plot_background plot (entire SVG element) background ( Element.Rect ) Security Considerations There is a significant security literature highlighting the risk associated with using embedded stylesheets. As a GGity user, you can address this risk in a few ways: Do not use GGity themes at all, by setting the :theme attribute of the Plot struct to nil . Use an external stylesheet that takes advantage of the classes that GGity attaches to elements of the plot. This option works well if plot styles do not need to be updated dynamically or stored in the same file as the SVG document. An external stylesheet also eliminates the overhead associated with generating and transmitting an embedded stylesheet every time the plot is rendered. Do not pass untrusted data (directly or indirectly) to Plot.theme/2 . Depending on your use case, this may or may not be difficult to enforce with confidence. If neither of these approaches are an option, GGity attempts to mitigate risk by HTML-escaping data that is rendered in a &lt;text&gt; element and by validating the values in each kind of Element struct prior to rendering. Most Element struct attributes are either colors (represented with strings) or numbers. GGity will not render those attributes if the value is invalid (colors must be a valid CSS color name or a hex value). Similarly, the :face attribute of an Element.Text struct is compared against a list of acceptable values. This leaves the :family attribute of an Element.Text struct. These values are HTML-escaped, but are not otherwise sanitized and should not be set using untrusted data.","ref":"GGity.Theme.html","title":"GGity.Theme","type":"module"},{"doc":"","ref":"GGity.Theme.html#t:t/0","title":"GGity.Theme.t/0","type":"type"},{"doc":"Common functions for transforming axis tick labels. Break (i.e. axis tick or legend item) labels are formatted based on a scale's :labels option. This option can be provided in several forms: nil - No labels are drawn :waivers - drawn using the default formatting ( Kernel.to_string/1 ) a function that takes a single argument representing the break value and returns a binary an atom, representing the name of a built-in formatting function (e.g., commas/1 ) Note that the built-in formatting functions are not intended to be robust. One option for finely-tuned formatting would be to pass functions from the Cldr family of packages (must be added as a separate dependency). Examples data |&gt; Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; } ) |&gt; Plot . geom_point ( ) |&gt; Plot . scale_x_continuous ( labels : nil ) # value 1000 is printed as an empty string data |&gt; Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; } ) |&gt; Plot . geom_point ( ) |&gt; Plot . scale_x_continuous ( ) # This is equivalent to Plot.scale_x_continuous(labels: :waivers) # value 1000 (integer) is printed as &quot;1000&quot; # value 1000.0 (float) is printed as &quot;1.0e3&quot; data |&gt; Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; , c : &quot;color&quot; } ) |&gt; Plot . geom_point ( ) |&gt; Plot . scale_color_viridis ( labels : fn value -&gt; value &lt;&gt; &quot;!&quot; end ) # value &quot;First Item&quot; is printed as &quot;First Item!&quot; data |&gt; Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; } ) |&gt; Plot . geom_point ( ) |&gt; Plot . scale_x_continuous ( labels : :commas ) # value 1000 (integer) is printed as &quot;1,000&quot; # value 1000 (float) is printed as &quot;1,000&quot; Date scales (e.g., GGity.Scale.X.Date ) are a special case. For those scales, if a value for :date_labels has been specified, that pattern overrides any value for the :labels option. See GGity.Plot.scale_x_date/2 for more information regarding date labels.","ref":"GGity.Labels.html","title":"GGity.Labels","type":"module"},{"doc":"Applies a comma separator to a number and converts it to a string. If the number is a float, it is first rounded using Kernel.to_string/1 . Note that simple floating point arithmetic is used; the various issues/errors associated with floating point values apply. iex&gt; GGity.Labels . commas ( 5000.0 ) &quot;5,000&quot; iex&gt; GGity.Labels . commas ( 1000.6 ) &quot;1,001&quot; iex&gt; GGity.Labels . commas ( 100.0 ) &quot;100&quot; iex&gt; GGity.Labels . commas ( 10_000_000 ) &quot;10,000,000&quot;","ref":"GGity.Labels.html#commas/1","title":"GGity.Labels.commas/1","type":"function"},{"doc":"Formats a number in U.S. dollars and cents. If the value is greater than or equal to 100,000 rounds to the nearest dollar and does not display cents. Note that simple floating point arithmetic is used; the various issues/errors associated with floating point values apply. iex&gt; GGity.Labels . dollar ( 5000.0 ) &quot;$5,000.00&quot; iex&gt; GGity.Labels . dollar ( 1000.6 ) &quot;$1,000.60&quot; iex&gt; GGity.Labels . dollar ( 100.0 ) &quot;$100.00&quot; iex&gt; GGity.Labels . dollar ( 10_000_000 ) &quot;$10,000,000&quot;","ref":"GGity.Labels.html#dollar/1","title":"GGity.Labels.dollar/1","type":"function"},{"doc":"Formats a number as a percent. Accepts a :precision option specifying the number of decimal places to be displayed. Note that simple floating point arithmetic is used; the various issues/errors associated with floating point values apply. iex&gt; GGity.Labels . percent ( 0.5 ) &quot;50%&quot; iex&gt; GGity.Labels . percent ( 0.111 ) &quot;11%&quot; iex&gt; GGity.Labels . percent ( 0.015 , precision : 1 ) &quot;1.5%&quot; iex&gt; GGity.Labels . percent ( 10 ) &quot;1000%&quot;","ref":"GGity.Labels.html#percent/2","title":"GGity.Labels.percent/2","type":"function"},{"doc":"","ref":"GGity.Labels.html#t:tick_value/0","title":"GGity.Labels.tick_value/0","type":"type"},{"doc":"GGity brings the familiar interface of R's ggplot2 library to SVG charting in Elixir.","ref":"readme.html","title":"GGity","type":"extras"},{"doc":"GGity brings a subset of the functionality of ggplot2 to creating data visualizations in Elixir. As such constructing a plot in GGity is based on the same priniciples - a plot is composed of one or more layers, where each layer includes: Data - in GGity, data is represented using Explorer dataframes. Plots can also be created from a list of maps; GGity will convert the list to a dataframe. GGity does not yet handle missing values or fancy values like :nan or :infinity . Geom - a visible shape/object (such a point, a bar or a line), the characteristics of which will be determined based on the values of the data (e.g., the x-coordinate mapped to one variable, the y-coordinate to another, the color of a point to a third variable). Mapping - a map that indicates which characteristics (aesthetics, in ggplot2 parlance) will be tied to which variables. Position adjustment - a method for adjusting the position of overlapping geoms. For example, a stacked bar chart maps x-coordinates and colors based on variables, but the y-coordinates for each part of the stack need to be adjusted in order to avoid placing all of the bars for one x value on top of one another. Stat (statistical transformation) - sometimes we do not actually want to map the data to shapes on plot. Instead we want to perform some calculations on the data and plot that. For example, a histogram plots the number of observations of a given value for a given variable organized into groups based on ranges of values (&quot;bins&quot;). Given a dataset, the plot is mapping those ranges and value counts to shapes, not the raw data. The calculation of those transformed values is a stat.","ref":"readme.html#overview","title":"GGity - Overview","type":"extras"},{"doc":"cities = Explorer.Series . from_list ( [ &quot;Houston&quot; , &quot;Fort Worth&quot; , &quot;San Antonio&quot; , &quot;Dallas&quot; , &quot;Austin&quot; ] ) # GGity includes several sample datasets in the Examples module Examples . tx_housing ( ) |&gt; Explorer.DataFrame . filter_with ( &amp; Explorer.Series . in ( &amp;1 [ &quot;city&quot; ] , cities ) ) # Only plot specific cities # Plot sales (x) by median price (y) |&gt; Plot . new ( %{ x : &quot;sales&quot; , y : &quot;median&quot; } ) # Add a title |&gt; Plot . labs ( title : &quot;Texas Home Values&quot; ) # Add a scatterplot layer; point color by city, with 40% opacity |&gt; Plot . geom_point ( %{ color : &quot;city&quot; } , alpha : 0.4 ) # Use built-in label formatter for the x-axis labels |&gt; Plot . scale_x_continuous ( labels : :commas ) # Custom format y-axis labels |&gt; Plot . scale_y_continuous ( labels : fn value -&gt; &quot;$ \#{ Labels . commas ( round ( value / 1000 ) ) } K&quot; end ) # Choose color palette for color scale and custom format legend labels |&gt; Plot . scale_color_viridis ( option : :magma , labels : fn value -&gt; &quot; \#{ value } !!!&quot; end ) # Generate SVG chart as an IO list for use in a Phoenix template or string |&gt; Plot . plot ( ) GGity supports scatterplots, bar charts, line charts, area/ribbon charts and boxplots. The GGity documentation includes guides for each geom and other key concepts with several examples of code and output. The plot background, axes, legends and other non-geom elements can be styled using the Theme interface (useful when there could be dynamic changes) or with an external stylesheet (plots generated by GGity include custom classes on these elements for this purpose).","ref":"readme.html#example","title":"GGity - Example","type":"extras"},{"doc":"GGity supports custom attributes, whereby each layer includes a function to which the row of data used to draw an individual geom is passed (along with the plot itself). This function must return a keyword list of values that will be added to the SVG element drawn for that data point. Custom attributes let the developer embed phx- event handlers, Alpine.js directives, or even plain Javascript to each shape drawn on the plot, tied to the data represented by that shape. For example: data |&gt; Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; } ) |&gt; Plot . geom_point ( custom_attributes : fn _plot , row -&gt; [ phx_click : &quot;filter_by_y&quot; , phx_value_y : row [ &quot;y&quot; ] ] end ) Draws a scatterplot where each &lt;circle&gt; element (which represents one row in the dataset) will include a phx-click handler and a phx-value-y data attribute with the value of the y variable for the shape clicked on. The event handler for that event could return a new plot with a dataset filtered to show only points within some specified range of the points clicked.","ref":"readme.html#liveview","title":"GGity - LiveView","type":"extras"},{"doc":"I am interested in data visualization and after learning a lot from the work being done on Contex , I decided that starting to write a basic clone of ggplot2 would help me learn more about the grammar of graphics, ggplot2 and how to develop a reasonably nontrivial library for Elixir. GGity's core design principle is that, if GGity supports a ggplot2 feature, it should be obvious to someone familiar with ggplot2 how to access that feature in the GGity API. Hewing as closely as possible to ggplot2 also has the benefit of keeping the API more stable. To the extent GGity supports features that extend or differ from the ggplot2 API, those interfaces are more likely to change. Extensions (things ggplot2 doesn't do, such as custom attributes) are likely to persist but could change as issues/improvements are discovered. Differences (things ggplot2 does, but in a different way) are almost always driven by my lack of figuring out how to implement a feature in a way that conforms to the ggplot2 approach. Those will change if/when I figure out how to do so.","ref":"readme.html#goals","title":"GGity - Goals","type":"extras"},{"doc":"I code as a hobby, so this is not something that is getting used frequently or in a production environment. I would love for people to try the library and provide feedback nonetheless.","ref":"readme.html#warning-and-invitation","title":"GGity - Warning and Invitation","type":"extras"},{"doc":"Contex - Contex is simpler and well-suited for dashboards, for example. GGity is intended to be more oriented towards statistical graphics. Those who just want to draw a simple bar chart and are not familiar with grammar of graphics concepts will likely find Contex easier to use. Visual tests GGity has decent unit test coverage, but given the domain, a picture is worth a thousand words. The test suite includes several livebooks that represent the primary testing tools.","ref":"readme.html#alternatives","title":"GGity - Alternatives","type":"extras"},{"doc":"The library includes an alias ( mix checks ) that runs Credo, the formatter and all the visual tests in sequence. I prefer to have all of those things in order before committing a change. GGity also includes guides that serve as a sort of visual doctest - the guides include several code examples, and those code examples are used to generate the graphics in the documents (so as a user you know that the code in the example will definitely generate the graphic in the documentation). Before pushing a new feature, the docs are rebuilt using mix build_docs . I am still working out how best to do this without making the commit history somewhat messy.","ref":"readme.html#build-process","title":"GGity - Build Process","type":"extras"},{"doc":"I am very grateful to @mindok, the author of Contex, who graciously accepted and provided feedback on contributions to that library, which in turn inspired me to write this (and flat out copy some a few parts of Contex in so doing). I do not view GGity as a replacement for Contex; it is a personal opportunity for me to learn a lot at my own pace. I made it public in case it might be helpful to others as an example. Acknowledgement is due to Hadley Wickham and others who have built ggplot2 ; the library is great, but Wickham's grammar of graphics is really an excellent piece of academic work in its own right. Along with Edward Tufte's book I think it is safe to say a golden age of visualization ensued. I also want to recognize contributors to the Explorer library, which to some degree inspired me to pick this back up again after a period of dormancy.","ref":"readme.html#acknowledgements","title":"GGity - Acknowledgements","type":"extras"},{"doc":"Add :ggity to your list of dependencies in mix.exs: def deps do [ { :ggity , &quot;~&gt; 0.5.0&quot; } ] end GGity requires Elixir 1.14.","ref":"readme.html#installation","title":"GGity - Installation","type":"extras"},{"doc":"This source code is licensed under the MIT license. Copyright (c) 2020-present, Steve Rowley.","ref":"readme.html#license","title":"GGity - License","type":"extras"},{"doc":"Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . plot ( ) # Add aesthetic mapping to color Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( %{ color : :cyl } ) |&gt; Plot . plot ( ) # Add aesthetic mapping to shape Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( %{ shape : :cyl } ) |&gt; Plot . plot ( ) # Add aesthetic mapping to size (for circles, a bubble chart) Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( %{ size : :qsec } ) |&gt; Plot . plot ( ) # Set aesthetics to fixed value Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( color : &quot;red&quot; , size : 5 ) |&gt; Plot . plot ( )","ref":"geom_point.html","title":"Points","type":"extras"},{"doc":"Examples . economics ( ) |&gt; Plot . new ( %{ x : &quot;date&quot; , y : &quot;unemploy&quot; } ) |&gt; Plot . geom_line ( ) |&gt; Plot . plot ( ) Examples . economics_long ( ) |&gt; Plot . new ( %{ x : &quot;date&quot; , y : &quot;value01&quot; , color : &quot;variable&quot; } ) |&gt; Plot . geom_line ( ) |&gt; Plot . plot ( ) Examples . economics ( ) |&gt; Plot . new ( %{ x : &quot;date&quot; , y : &quot;unemploy&quot; } ) |&gt; Plot . geom_line ( color : &quot;red&quot; ) |&gt; Plot . plot ( )","ref":"geom_line.html","title":"Lines","type":"extras"},{"doc":"Examples . mpg ( ) |&gt; Plot . new ( %{ x : &quot;class&quot; } ) |&gt; Plot . geom_bar ( ) |&gt; Plot . plot ( ) Examples . mpg ( ) |&gt; Plot . new ( %{ x : &quot;class&quot; } ) |&gt; Plot . geom_bar ( %{ fill : &quot;drv&quot; } ) |&gt; Plot . plot ( )","ref":"geom_bar.html","title":"Bars","type":"extras"},{"doc":"Examples . mpg ( ) |&gt; Plot . new ( %{ x : &quot;class&quot; , y : &quot;hwy&quot; } ) |&gt; Plot . geom_boxplot ( ) |&gt; Plot . plot ( ) Examples . mpg ( ) |&gt; Plot . new ( %{ x : &quot;class&quot; , y : &quot;hwy&quot; } ) |&gt; Plot . geom_boxplot ( fill : &quot;white&quot; , color : &quot;#3366FF&quot; ) |&gt; Plot . plot ( ) Examples . mpg ( ) |&gt; Plot . new ( %{ x : &quot;class&quot; , y : &quot;hwy&quot; } ) |&gt; Plot . geom_boxplot ( outlier_color : &quot;red&quot; ) |&gt; Plot . plot ( ) Examples . mpg ( ) |&gt; Plot . new ( %{ x : &quot;class&quot; , y : &quot;hwy&quot; } ) |&gt; Plot . geom_boxplot ( %{ color : &quot;drv&quot; } ) |&gt; Plot . plot ( )","ref":"geom_boxplot.html","title":"Boxplot","type":"extras"},{"doc":"Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg , label : :model } ) |&gt; Plot . geom_text ( ) |&gt; Plot . plot ( ) # Set the font size for the label Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg , label : :model } ) |&gt; Plot . geom_text ( size : 10 ) |&gt; Plot . plot ( ) # Shift positioning Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg , label : :model } ) |&gt; Plot . geom_point ( size : 2 ) |&gt; Plot . geom_text ( size : 5 , hjust : :left , nudge_x : 3 ) |&gt; Plot . plot ( ) Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg , label : :model } ) |&gt; Plot . geom_point ( size : 2 ) |&gt; Plot . geom_text ( size : 5 , vjust : :top , nudge_y : 3 ) |&gt; Plot . plot ( ) # Map other aesthetics Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg , label : :model } ) |&gt; Plot . geom_text ( %{ color : :cyl } , size : 5 ) |&gt; Plot . plot ( ) # Add a text annotation Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg , label : :model } ) |&gt; Plot . geom_text ( size : 5 ) |&gt; Plot . annotate ( :text , label : &quot;plot mpg vs. wt&quot; , x : 1.5 , y : 15 , size : 8 , color : &quot;red&quot; ) |&gt; Plot . plot ( ) # Bar chart labelling [ %{ x : &quot;1&quot; , y : 1 , grp : &quot;a&quot; } , %{ x : &quot;1&quot; , y : 3 , grp : &quot;b&quot; } , %{ x : &quot;2&quot; , y : 2 , grp : &quot;a&quot; } , %{ x : &quot;2&quot; , y : 1 , grp : &quot;b&quot; } , ] |&gt; Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; , group : &quot;grp&quot; } ) |&gt; Plot . geom_col ( %{ fill : &quot;grp&quot; } , position : :dodge ) |&gt; Plot . geom_text ( %{ label : &quot;y&quot; } , position : :dodge , size : 6 ) |&gt; Plot . plot ( ) # Nudge the label up a bit [ %{ x : &quot;1&quot; , y : 1 , grp : &quot;a&quot; } , %{ x : &quot;1&quot; , y : 3 , grp : &quot;b&quot; } , %{ x : &quot;2&quot; , y : 2 , grp : &quot;a&quot; } , %{ x : &quot;2&quot; , y : 1 , grp : &quot;b&quot; } , ] |&gt; Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; , group : &quot;grp&quot; } ) |&gt; Plot . geom_col ( %{ fill : &quot;grp&quot; } , position : :dodge ) |&gt; Plot . geom_text ( %{ label : &quot;y&quot; } , position : :dodge , size : 6 , nudge_y : 4 ) |&gt; Plot . plot ( ) # Position label in the middle of stacked bars [ %{ x : &quot;1&quot; , y : 1 , grp : &quot;a&quot; } , %{ x : &quot;1&quot; , y : 3 , grp : &quot;b&quot; } , %{ x : &quot;2&quot; , y : 2 , grp : &quot;a&quot; } , %{ x : &quot;2&quot; , y : 1 , grp : &quot;b&quot; } , ] |&gt; Plot . new ( %{ x : &quot;x&quot; , y : &quot;y&quot; , group : &quot;grp&quot; } ) |&gt; Plot . geom_col ( %{ fill : &quot;grp&quot; } ) |&gt; Plot . geom_text ( %{ label : &quot;y&quot; } , position : :stack , position_vjust : 0.5 , size : 6 ) |&gt; Plot . plot ( )","ref":"geom_text.html","title":"Text","type":"extras"},{"doc":"# The viridis scale is the default color scale Examples . diamonds ( ) |&gt; Explorer.DataFrame . sample ( 1000 , seed : 100 ) |&gt; Plot . new ( %{ x : &quot;carat&quot; , y : &quot;price&quot; } ) |&gt; Plot . geom_point ( %{ color : &quot;clarity&quot; } ) |&gt; Plot . plot ( ) # Use the :option option to select a palette cities = Explorer.Series . from_list ( [ &quot;Houston&quot; , &quot;Fort Worth&quot; , &quot;San Antonio&quot; , &quot;Dallas&quot; , &quot;Austin&quot; ] ) Examples . tx_housing ( ) |&gt; Explorer.DataFrame . filter_with ( &amp; Explorer.Series . in ( &amp;1 [ &quot;city&quot; ] , cities ) ) |&gt; Plot . new ( %{ x : &quot;sales&quot; , y : &quot;median&quot; } ) |&gt; Plot . geom_point ( %{ color : &quot;city&quot; } ) |&gt; Plot . scale_color_viridis ( option : :plasma ) |&gt; Plot . plot ( ) cities = Explorer.Series . from_list ( [ &quot;Houston&quot; , &quot;Fort Worth&quot; , &quot;San Antonio&quot; , &quot;Dallas&quot; , &quot;Austin&quot; ] ) Examples . tx_housing ( ) |&gt; Explorer.DataFrame . filter_with ( &amp; Explorer.Series . in ( &amp;1 [ &quot;city&quot; ] , cities ) ) |&gt; Plot . new ( %{ x : &quot;sales&quot; , y : &quot;median&quot; } ) |&gt; Plot . geom_point ( %{ color : &quot;city&quot; } ) |&gt; Plot . scale_color_viridis ( option : :inferno ) |&gt; Plot . plot ( )","ref":"scale_color_viridis.html","title":"Color/Fill Viridis","type":"extras"},{"doc":"Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . plot ( ) # Examples below assume that element constructors are imported # e.g. `import GGity.Element.{Line, Rect, Text} # Plot formatting Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . theme ( plot_title : element_text ( size : 10 ) ) |&gt; Plot . plot ( ) Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . theme ( plot_background : element_rect ( fill : &quot;green&quot; ) ) |&gt; Plot . plot ( ) # Panel formatting Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . theme ( panel_background : element_rect ( fill : &quot;white&quot; , color : &quot;grey&quot; ) ) |&gt; Plot . plot ( ) Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . theme ( panel_grid_major : element_line ( color : &quot;black&quot; ) ) |&gt; Plot . plot ( ) # Axis formatting Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . theme ( axis_line : element_line ( size : 6 , color : &quot;grey&quot; ) ) |&gt; Plot . plot ( ) Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . theme ( axis_text : element_text ( color : &quot;blue&quot; ) ) |&gt; Plot . plot ( ) Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . theme ( axis_ticks : element_line ( size : 4 ) ) |&gt; Plot . plot ( ) # Turn the x-axis ticks inward Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . labs ( title : &quot;Fuel economy declines as weight decreases&quot; ) |&gt; Plot . theme ( axis_ticks_length_x : - 2 ) |&gt; Plot . plot ( ) # GGity does not support legend position, but legend key boxes # and text can be styled as you would expect # Default styling Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( %{ color : :cyl , shape : :vs } ) |&gt; Plot . labs ( x : &quot;Weight (1000 lbs)&quot; , y : &quot;Fuel economy (mpg)&quot; , color : &quot;Cylinders&quot; , shape : &quot;Transmission&quot; ) |&gt; Plot . plot ( ) # Style legend keys Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( %{ color : :cyl , shape : :vs } ) |&gt; Plot . labs ( x : &quot;Weight (1000 lbs)&quot; , y : &quot;Fuel economy (mpg)&quot; , color : &quot;Cylinders&quot; , shape : &quot;Transmission&quot; ) |&gt; Plot . theme ( legend_key : element_rect ( fill : &quot;white&quot; , color : &quot;black&quot; ) ) |&gt; Plot . plot ( ) # Style legend text Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( %{ color : :cyl , shape : :vs } ) |&gt; Plot . labs ( x : &quot;Weight (1000 lbs)&quot; , y : &quot;Fuel economy (mpg)&quot; , color : &quot;Cylinders&quot; , shape : &quot;Transmission&quot; ) |&gt; Plot . theme ( legend_text : element_text ( size : 4 , color : &quot;red&quot; ) ) |&gt; Plot . plot ( ) # Style legend title Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( %{ color : :cyl , shape : :vs } ) |&gt; Plot . labs ( x : &quot;Weight (1000 lbs)&quot; , y : &quot;Fuel economy (mpg)&quot; , color : &quot;Cylinders&quot; , shape : &quot;Transmission&quot; ) |&gt; Plot . theme ( legend_title : element_text ( face : &quot;bold&quot; ) ) |&gt; Plot . plot ( )","ref":"theme.html","title":"Theme","type":"extras"},{"doc":"Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . annotate ( :text , x : 4 , y : 25 , label : &quot;Some text&quot; ) |&gt; Plot . plot ( ) Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . annotate ( :rect , xmin : 3 , xmax : 4.2 , ymin : 12 , ymax : 21 , alpha : 0.2 ) |&gt; Plot . plot ( ) Examples . mtcars ( ) |&gt; Plot . new ( %{ x : :wt , y : :mpg } ) |&gt; Plot . geom_point ( ) |&gt; Plot . annotate ( :segment , x : 2.5 , xend : 4 , y : 15 , yend : 25 , color : &quot;blue&quot; ) |&gt; Plot . plot ( )","ref":"annotate.html","title":"Annotate","type":"extras"}]